﻿using Acme.BookStore.Customers;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Volo.Abp;
using Volo.Abp.Domain.Services;

namespace Acme.BookStore.BookIssued
{
    public class BookIssueManager : DomainService
    {
        private readonly IBookIssueRepository _bookIssueRepository;
        public BookIssueManager(IBookIssueRepository bookIssueRepository)
        {
            _bookIssueRepository = bookIssueRepository;
        }

        public async Task<BookIssue> CreateAsync(
         BookIssue bookissue)
        { 
            var existingBookIssue = await _bookIssueRepository.FindBookIssueCustomer(bookissue.customerId,bookissue.bookId);
            if (existingBookIssue != null)
            {
                throw new BookIssueErrorException(existingBookIssue.customerName, existingBookIssue.bookName);
            }
            return new BookIssue(
                GuidGenerator.Create(),
                bookissue.bookId,
                bookissue.customerId
            );
        }

    }
}
